GNU C Library NEWS -- history of user-visible changes.
Copyright (C) 1992-2026 Free Software Foundation, Inc.
See the end for copying conditions.

Please send GNU C library bug reports via <https://sourceware.org/bugzilla/>
using `glibc' in the "product" field.

Version 2.44

Major new features:

* System-wide tunables can be applied using /etc/tunables.conf and
  running ldconfig.  Specific tunable settings and the
  /etc/tunables.conf file format and path are not part of the stable
  library interfaces and may change between releases.

* A new tunable, glibc.elf.thp, is added to map read-only segments with
  Transparent Huge Pages (THP) if THP is not disabled in the kernel.  When
  glibc.elf.thp is set to 1, malloc uses the actual kernel THP mode
  instead of defaulting to madvise mode and madvise_thp will stop issuing
  MADV_HUGEPAGE if kernel THP mode is always.

* The THP page size in malloc is capped to MAX_THP_PAGESIZE.  If the THP
  page size is above MAX_THP_PAGESIZE, THP in malloc is disabled.

* Additional optimized and correctly rounded mathematical functions have
  been imported from the CORE-MATH project, in particular cosh, sinh, and
  tanh.

* Many additional improvements to existing functions have been synchronized
  from the CORE-MATH project.

* For C++26, the assert macro is now variadic, allowing more complex
  arguments containing commas (which however still must evaluate to a single
  value).

* The SVID error handling for cosh and sinh was moved to compatibility
  symbols, allowing improvements in performance.

* Static PIE is now supported for arm-*-linux-gnueabi.  It requires toolchain
  support to correctly set the expected linker options.

* On AArch64 targets that support the Guarded Control Stack extension all GCS
  operations (including status, write on shadow stack, and push to shadow
  stack) are locked after enabling GCS with ENFORCED or OVERRIDE GCS policy.
  When a GCS operation is locked, a program cannot change this operation
  status via the prctl syscall.  This prevents disabling or corrupting the
  GCS shadow stack during runtime.

* On AArch64 targets, log, exp, sin, cas, sinh, cosh, asinh, acosh, atanh
  single and double precision special cases have been vectorized for SVE and
  AdvSIMD, and vector variants of powr have been added.

* On RISC-V targets, vector extension optimized variants of memcmp, memccpy,
  memchr, memcpy, memmove, stpncpy, strcmp, strchr, strcpy, strncmp, strncpy,
  strlen, and strrchr have been added.

* On PowerPC, memchr optimized for Power10 has been re-added.

* Support for LoongArch32 has been added.

* Pre-built ld.so.cache files can be installed with ldconfig.

* A new locale has been added: hrx_BR (Hunsrik language spoken in Brazil).

Deprecated and removed features, and other changes affecting compatibility:

* Although malloc and related functions currently return pointers
  aligned to alignof (max_align_t), the documentation now says future
  versions of glibc may relax alignment requirements for small allocations.
  For example, a future malloc(1) might return a pointer with odd
  alignment, because no object of size 1 can have a fundamental
  alignment greater than 1.

* The s390-linux-gnu (31bit) configuration is no longer supported.

* The --enable-memory-tagging configure option has been removed.
  The corresponding AArch64-specific functionality that was previously
  activated by this flag has been removed as well.

* The --enable-static-nss configure option has been removed.  It had no
  effect on the build since the NSS reorganization in glibc 2.33; its only
  remaining behavior was to suppress the link-time warnings on the NSS
  interface functions in libc.a, which are now emitted unconditionally.

Security related changes:

The following CVEs were fixed in this release, details of which can be
found in the advisories directory of the release tarball:

  GLIBC-SA-2026-0005:
    gethostbyaddr and gethostbyaddr_r may incorrectly handle DNS
    response (CVE-2026-4437)

  GLIBC-SA-2026-0006:
    gethostbyaddr and gethostbyaddr_r return invalid DNS hostnames
    (CVE-2026-4438)

  GLIBC-SA-2026-0007:
    iconv crash due to assertion failure with untrusted input
    (CVE-2026-4046)

The following bugs were resolved with this release:

  [2363] libc: EOPNOTSUPP and ENOTSUP in errno.h must be different,
    according to SUSv3
  [3794] manual: iconv: //TRANSLIT and //IGNORE feature not documented
  [15792] dynamic-link: [arm] ARM dynamic linker should save/restore
    coprocessor registers
  [20331] libc: fts ignores errors from readdir()
  [20680] dynamic-link: ifunc resolver cannot access the thread pointer
    with static linking
  [22944] libc: fts cannot traverse paths which have a length longer
    than USHRT_MAX
  [25257] libc: sotruss: fix error message for '--f' argument
  [25770] locale: newlocale memory leak in LOCPATH parsing and on error
    paths
  [27582] libc: x86_64: IFUNC in static user programs may crash when
    built with -fstack-protector-all
  [28218] dynamic-link: ld.so: ifunc resolver calls a lazy PLT. When
    does it work?
  [28817] libc: static-pie ifunc resolver tls failure
  [28940] nss: __nss_database_get doesn't check for allocation failure
  [30136] manual: Please document behaviour of iconv(3) when input is
    untranslatable
  [30304] nptl: nptl/tst-pthread-gdb-attach test fails with new libc
    shared library version
  [30769] malloc: malloc_trim is not working correctly for arenas other
    than arena 0
  [30976] dynamic-link: rtld: resolve ifunc relocations after
    JUMP_SLOT/GLOB_DAT/etc
  [30992] libc: alpha: setrlimit() with negative values besides
    RLIM_INFINITY returns EPERM
  [31901] libc: elf/tst-glibc-hwcaps-prepend-cache fails on i686
  [33226] math: math-vector-fortran.h vs not ffast-math
  [33626] libc: execvpe should skip inaccessible $PATH components
  [33650] build: abilist.awk doesn't handle unversioned defined symbols
  [33785] stdio: New streams are linked into global list before they are
    fully initialized
  [33848] build: Build fails at openat2.h, redefinition of 'struct
    open_how'
  [33882] libc: Recursion in nftw() causes stack overflow(CWE-674)
  [33904] build: error: '__vasprintf_chk' undeclared here
  [33921] build: Building with Linux-7.0-rc1 errors on OPEN_TREE_CLONE
  [33935] stdio: _IO_wfile_doallocate not linked correctly when linking
    glibc statically
  [33980] locale: iconv: ibm139x trigger assertion error when converting
    to internal while lack enough room (CVE-2026-4046)
  [33985] build: ld: cannot find -lgcc_s: No such file or directory
  [33999] stdio: libio: potential dangling _IO_save_base or memory leak
    in wgenops.c
  [34006] stdio: libio: inconsistent fmemopen_write behavior on last \0
  [34008] stdio: stdio-common: scanf %mc pattern will cause heap
    overflow when width > 1024
  [34014] nss: gethostbyaddr and gethostbyaddr_r may incorrectly handle
    DNS response
  [34015] nss: gethostbyaddr and gethostbyaddr_r return invalid DNS
    hostnames
  [34019] stdio: libio: undefined behavior when setbuf on open_memstream
  [34033] network: resolv/ns_print.c: ns_sprintrrf TSIG path bypasses
    buflen and can overflow caller buffer
  [34064] dynamic-link: The unnecessary PT_NOTE check in when loading a
    binary
  [34069] network: Buffer overread in ns_sprintrrf with corrupted RDATA
    field (CVE-2026-6238)
  [34070] hurd: Calling open ("/dev/tty/", O_RDONLY) causes the program
    to segfault
  [34073] regex: regexec can mistakenly match with backrefs and the $
    anchor
  [34079] dynamic-link: THP segment load aligns all PT_LOAD segments to
    THP page size
  [34080] dynamic-link: Support THP segment load with THP enabled with
    madvise
  [34083] dynamic-link: __get_thp_mode and __get_thp_size are called
    twice
  [34090] libc: wordexp WRDE_APPEND rollback restores stale we_wordv,
    leading to invalid free in wordfree
  [34098] libc: Missing SUPPORT_STATIC_PIE in arm32
  [34129] string: x86: Non-temporal memset unreachable on AMD Zen 3/4/5
  [34144] libc: ld.so clobbers VFP registers during runtime linking
  [34154] network: Segfault in sock_eq after res_init() returns -1, due
    to stale _u._ext.nscount in __res_iclose
  [34156] dynamic-link: dlsym(RTLD_DEFAULT, ...) from a constructor
    SIGSEGVs when tail-called
  [34164] dynamic-link: elf: IFUNC resolvers do not see static TLS
    initialization
  [34170] dynamic-link: elf:  IFUNC resolver reading global-
    dynamic/TLSDESC __thread variable crashes inside __tls_get_addr
  [34183] math: fma produces wrong results
  [34192] nptl: pthread_setname_np opens /proc/<tid>/comm with O_RDWR
    instead of O_WRONLY|O_CLOEXEC
  [34196] libc: elf: static dlopen: pointer guard of the loaded
    ld.so/libc.so is left uninitialized
  [34197] dynamic-link: elf: Stack canary and pointer guard are
    recoverable from AT_RANDOM (getauxval)
  [34205] libc: aarch64: SIGSEGV in tunable_strcmp in static-pie
    binaries run with a string tunable
  [34208] stdio: scanf not pushback after matching failure
  [34210] libc: elf/tst-glibc-hwcaps-prepend-cache fails on
    armv7a-unknown-linux-gnueabihf
  [34236] locale: Non-representable transliteration still causes iconv
    to exit with 1 if //TRANSLIT is specified
  [34289] network: ns_sprintrrf uses p_class, p_type internally
  [34311] build: THP tests failed to link
  [34347] libc: Incorrect trailing bitfield word of struct tcp_info
  [34348] dynamic-link: FAIL: elf/tst-thp-1 if THP is disabled in kernel
  [34351] build: Random test failures
  [34355] build: [2.44 Regression] "make check -j7 subdirs=stdio-common"
    no longer works
  [34396] libc: sparc64-unknown-linux-gnu , Gentoo: >200 test failures,
    SIGILL in many binaries
  [34398] string: Truncated strncpy on s390x z900 ifunc variant

Version 2.43

Major new features:

* The ISO C23 free_sized, free_aligned_sized, memset_explicit, and
  memalignment functions have been added.

* As specified in ISO C23, the assert macro is defined to take variable
  arguments to support expressions with a comma inside a compound
  literal initializer not surrounded by parentheses.

* For ISO C23, the functions bsearch, memchr, strchr, strpbrk, strrchr,
  strstr, wcschr, wcspbrk, wcsrchr, wcsstr and wmemchr that return
  pointers into their input arrays now have definitions as macros that
  return a pointer to a const-qualified type when the input argument is
  a pointer to a const-qualified type.

* The ISO C23 typedef names long_double_t, _Float32_t, _Float64_t, and
  (on platforms supporting _Float128) _Float128_t, introduced in TS
  18661-3:2015, have been added to <math.h>.

* The ISO C23 optional time bases TIME_MONOTONIC, TIME_ACTIVE, and
  TIME_THREAD_ACTIVE have been added.

* On Linux, the mseal function has been added.  It allows for sealing
  memory mappings to prevent further changes during process execution,
  such as changes to protection permissions, unmapping, relocation to
  another location, or shrinking the size.

* Additional optimized and correctly rounded mathematical functions have
  been imported from the CORE-MATH project, in particular acosh, asinh,
  atanh, erf, erfc, lgamma, and tgamma.

* Optimized implementations for fma, fmaf, remainder, remaindef, frexpf,
  frexp, frexpl (binary128), and frexpl (intel96) have been added.

* The SVID handling for acosf, acoshf, asinhf, atan2f, atanhf, coshf, fmodf,
  lgammaf/lgammaf_r, log10f, remainderf, sinhf, sqrtf, tgammaf, y0/j0,
  y1/j1, and yn/jn was moved to compat symbols, allowing improvements in
  performance.

* Experimental support for building with clang has been added.  It requires
  at least clang version 18, aarch64-linux-gnu or x86_64-linux-gnu
  targets, and a libgcc compatible runtime (including libgcc_s.so for
  pthread cancellation and backtrace runtime support).

* On Linux, the openat2 function has been added.  It is an extension of
  openat and provides a superset of its functionality.  It is supported only
  in LFS mode and is a cancellable entrypoint.

* On AArch64, support for 2MB transparent huge pages has been enabled by
  default in malloc (similar to setting glibc.malloc.hugetlb=1 tunable).

* On AArch64 Linux targets supporting the Scalable Matrix Extension
  (SME), the clone() system call wrapper will disable the ZA state of the
  SME.

* On AArch64 targets supporting the Branch Target Identification (BTI)
  extension, it is possible to enforce that all binaries in the process
  support BTI using the glibc.cpu.aarch64_bti tunable.

* On AArch64 Linux targets supporting at least one of the branch protection
  extensions (e.g. Branch Target Identification or Guarded Control Stack), it
  is possible to use LD_DEBUG=security to make the dynamic linker show
  warning messages about loaded binaries that do not support the
  corresponding security feature.

* On AArch64, vector variants of the new C23 exp2m1, exp10m1, log10p1,
  log2p1, and rsqrt routines have been added.

* On RISC-V, an RVV-optimized implementation of memset has been added.

* On x86, support for the Intel Nova Lake and Wildcat Lake processors
  has been added.

* The test suite has seen significant improvements in particular around
  the scanf, strerror, strsignal functions and multithreaded testing.

* Unicode support has been updated to Unicode 17.0.0.

* The manual has been updated and modernized, in particular also regarding
  many of its code examples.

Deprecated and removed features, and other changes affecting compatibility:

* Support for dumped heaps has been removed.  malloc_set_state() now always
  returns the error code -1.

* The aforementioned change in ISO C23 of the declaration of bsearch,
  memchr, strchr, strpbrk, strrchr, strstr, wcschr, wcspbrk, wcsrchr,
  wcsstr, and wmemchr as const-preserving macros can lead to compilation
  issues in code not set up for it. In particular, gnulib snapshots may need
  to be updated.

* The uimaxabs function has been renamed to umaxabs, following a change
  to the name of that function in ISO C2Y.  The old function continues
  to exist as a compatibility symbol for old binaries.

* The fromfp, fromfpx, ufromfp and ufromfpx functions, and the
  corresponding functions for other floating-point types, now return
  their result in the same type as their floating-point argument, rather
  than intmax_t or uintmax_t, in accordance with a change to the
  definition of these functions in ISO C23.  Existing binaries that use
  the versions returning intmax_t or uintmax_t will continue to work.

* The support for TX lock elision of pthread mutexes has been removed on all
  architectures (powerpc, s390x, x86_64).

* The next linux 6.19 release will remove support for compat syscalls on s390x.
  Therefore the s390-linux-gnu (31bit) configuration is deprecated in the
  glibc 2.43 release and will then be removed with glibc 2.44 release.
  Note that s390x-linux-gnu (64bit) remains supported.

Changes to build and runtime requirements:

* The LD_PROFILE functionality no longer has a default directory for the
  profile data it writes.  Instead, developers are required to set a
  directory explicitly using the LD_PROFILE_OUTPUT environment variable.
  To restore the previous, insecure behavior, processes can be run with
  LD_PROFILE_OUTPUT=/var/tmp.

Security related changes:

The following CVEs were fixed in this release, details of which can be
found in the advisories directory of the release tarball:

  GLIBC-SA-2026-0001:
    Integer overflow in memalign leads to heap corruption
    (CVE-2026-0861)

  GLIBC-SA-2026-0002:
    getnetbyaddr and getnetbyaddr_r leak stack contents to DNS resovler
    (CVE-2026-0915)

  GLIBC-SA-2026-0003:
    wordexp with WRDE_REUSE and WRDE_APPEND may return uninitialized
    memory (CVE-2025-15281)

The following bugs were resolved with this release:

  [15503] math: [arm] Support ARM VFPv4 VFMA instruction in fma
  [20473] manual: Missing word in stack allocation documentation.
  [24657] manual: Two mistakes in manual index
  [25669] dynamic-link: Provide extra information when a found library
    file is not suitable
  [28038] stdio: getdelim()/getline() does not add NUL terminator if
    first character is EOF.
  [28267] nptl: nptl: pthread_exit should set cancellation type and
    state
  [28327] math: Wrong return type for {,u}fromfp{,x} functions
  [28376] libc: [meta] Build glibc with Clang
  [29326] math: Usage of double in sqrtf
  [30635] glob: stack-overflow /build/glibc-
    SzIz7B/glibc-2.31/posix/../posix/glob.c:546:9 in glob64
  [31470] libc: inttypes.h provides incorrect macro definitions
  [31664] libc: rfe: please provide openat2()
  [31943] dynamic-link: _dl_find_object can fail if ld.so contains gaps
    between load segments
  [32339] build: iconv functions do not follow symlinks
  [32378] libc: Implement memset_explicit
  [32583] libc: setup_vdso doesn't support two PT_LOAD segments if one
    of them has zero-vaddr
  [32994] libc: pthread_rwlock_init reinitialisation during calls to
    fork()
  [33093] manual: Typo in section 16.9.8 Out-of-Band Data of the manual
  [33129] dynamic-link: Need a version tag to indicate that glibc has
    working GNU2 TLS support
  [33182] build: Some tests leave random directories under /tmp
  [33190] localedata: localedata: Add en_SE for ISO8601 date and time
  [33212] dynamic-link: Add GLIBC_ABI_DT_X86_64_PLT version to indicate
    x86_64 psABI compliance for DT_X86_64_PLT* support
  [33221] dynamic-link: Add GLIBC_ABI_GNU_TLS version to indicate the
    working GNU TLS run-time
  [33227] network: namespace violation in inet-fortified.h
  [33234] libc: s390: Test tst-locale1 fails on s390 32-bit
  [33245] nptl: nptl: error in internal cancellation syscall handling,
    corrupting copy_file_range syscall return value
  [33254] libc: tst-freopen4-mem and tst-freopen64-4-mem FAIL
  [33286] build: Test failure with glibc built with -mno-direct-extern-
    access
  [33289] localedata: Update locale data to Unicode 17.0.0
  [33300] stdio: strip --strip-unneeded "breaks" libc.a (causing
    segfault in Rust programs linked libc statically)
  [33311] build: Testing failure with clang
  [33312] build: Disable -Wimplicit-fallthrough for clang
  [33318] build: -c shouldn't be passed to LIBC_TRY_TEST_CC_OPTION
  [33325] libc: ISO C2y renamed s/uimaxabs/umaxabs/
  [33340] libc: Possible regression in 2.42 termios refactoring re non-
    standard baud rate
  [33356] nptl: creating thread stack with guardsize 0 can erroneously
    conclude MADV_GUARD_INSTALL is available
  [33361] nss: Group merge does not handle ERANGE during merge
  [33376] build: GCC 16 fails to build glibc when configured with
    --disable-default-pie --enable-profile
  [33404] dynamic-link: ld.so crashes when compiled with -Os and
    configured with --enable-stack-protector=all
  [33405] math: Optimize modf/modff for x86_64-v2 aren't compiled with
    -fsignaling-nans
  [33411] math: powl() raises spurious overflow
  [33425] build: setfpucw.c:25:17: error: variable ‘cw’ set but not used
    [-Werror=unused-but-set-variable=]
  [33519] nss: getXXX API fails for turkish locale if nsswitch.conf
    contains "i"
  [33542] libc: x86: wmemset ifunc: stray '!' causing SSE2
  [33547] libc: microblaze: wrong __syscall_cancel_arch after
    89b53077d2a58f00e7debdfe58afabe953dac60d
  [33563] math: powf() fails for 0x1p+8192 ^ 1.0
  [33586] math: [2.43 Regression] FAIL: math/test-float64x-pow
  [33619] math: [2.43 Regression] Many math test failures on x86-64
  [33627] libc: execvp reads uninitialized memory
  [33632] nptl: Incorrect USE_64B_ATOMICS usage on struct new_sem
  [33653] time: __fts64_children_time64 Does Not Support 2038 Problem
  [33677] math: [2.43 Regression] Many math test failures
  [33715] nptl: nptl: pthread_create might act as a cancellation
    entrypoint
  [33717] nptl: nptl:
    pthread_join/pthread_timedjoin_np/pthread_clockjoin_np might not act
    as cancellation entrypoint
  [33752] manual: Doc incorrectly says double and long double may not be
    distinct
  [33814] glob: wordexp with WRDE_REUSE and WRDE_APPEND may return
    uninitialized memory

Version 2.42

Major new features:

* The following ISO C23 function families (introduced in TS
  18661-4:2015) are now supported in <math.h>.  Each family includes
  functions for float, double, long double, _FloatN and _FloatNx, and a
  type-generic macro in <tgmath.h>.

  - Power and absolute-value functions: compoundn, pown, powr, rootn,
    rsqrt.

* On Linux, the pthread_gettid_np function has been added.

* The ISO C2Y family of unsigned abs functions, i.e. uabs, ulabs,
  ullabs, and uimaxabs, is now supported.

* On Linux, the <termios.h> interface now supports arbitrary baud rates;
  speed_t is redefined to simply be the baud rate specified as an
  unsigned int, which matches the kernel interface.

* The thread-local cache in malloc (tcache) now supports caching of
  large blocks.  This feature can be enabled by setting the tunable
  glibc.malloc.tcache_max to a larger value (max 4194304). Tcache is
  also significantly faster for small sizes.

* A new configure option, "--enable-sframe", can be used to enable
  SFrame support of the GNU C Libraries.  SFrame is a new stack trace
  information format which can be used by backtrace.  It requires
  binutils with a minimum version of 2.45.

* Support for lightweight stack guard pages via madvise and the
  MADV_GUARD_INSTALL flag has been added to pthread_create.

* Additional optimized and correctly rounded mathematical functions have
  been imported from the CORE-MATH project, in particular acospif,
  asinpif, atanpif, atan2pif, cospif, sinpif, tanpif.

* The testsuite has been significantly extended, including coverage of
  the functionality of the printf and scanf function families in many
  variants.

* The manual has been significantly extended and updated, particularly
  the threads, terminal, filesystem, resource, and math chapters.

* Code has been added to detect the x86-64 Intel Arrow Lake, Panther
  Lake, Clearwater Forest, and Diamond Rapids microarchitectures.

* Regarding S390, support for the new z17 platform has been added.

Deprecated and removed features, and other changes affecting compatibility:

* The glibc.rtld.execstack tunable now supports a compatibility mode to
  allow programs that require an executable stack through dynamically
  loaded shared libraries.

* On Linux, the <termio.h> header and the definition of struct termio
  in <sys/ioctl.h> have been removed. The termio interface has been
  obsolete since the very first version of POSIX.1 in 1988, replaced
  with <termios.h>.

* The support for TX lock elision of pthread mutexes has been deprecated
  on all architectures and will be removed in the next release.

* On AArch64 Linux targets supporting the Scalable Matrix Extension
  (SME), setjmp and sigsetjmp will disable the ZA state of SME.

Changes to build and runtime requirements:

* GCC 12.1 or later is now required to build the GNU C Library.

* GNU Binutils 2.39 or later is now required to build the GNU C Library.

Security related changes:

The following CVEs were fixed in this release, details of which can be
found in the advisories directory of the release tarball:

  GLIBC-SA-2025-0001:
    assert: Buffer overflow when printing assertion failure message
    (CVE-2025-0395)

  GLIBC-SA-2025-0003:
    power10: strcmp fails to save and restore nonvolatile vector
    registers (CVE-2025-5702)

  GLIBC-SA-2025-0004:
    power10: strncmp fails to save and restore nonvolatile vector
    registers (CVE-2025-5745)

  GLIBC-SA-2025-0005:
    posix: Fix double-free after allocation failure in regcomp
    (CVE-2025-8058)

The following bugs were resolved with this release:

  [5994] stdio: fflush after ungetc on seekable input stream
  [12724] stdio: fclose violates POSIX 2008 on seekable input streams
  [25263] dynamic-link: ldd and ld.so fail to resolve $ORIGIN with cross
    dir symlink
  [27880] nptl: Please provide a pthread pid accessor
  [29190] dynamic-link: Symbols with version hash zero lead to crashes,
    not matched correctly
  [29459] stdio: fwrite does not return EPIPE when underlying write
    fails with EPIPE.
  [31791] nss: [Regression] nss: memory for >8 elements in nsswitch.conf
    is not freed
  [32058] libc: qsort leaks memory if C++ exception is thrown from
    comparison function
  [32269] dynamic-link: RISC-V IFUNC resolver cannot access gp pointer
  [32369] stdio: fflush(NULL) doesn't properly flush files opened in
    read mode
  [32411] math: THREEp96 seems wrong
  [32412] dynamic-link: Initial DTV is reallocated using main realloc in
    auditing mode
  [32483] locale: ctype.h macros segfault in multithreaded programs with
    multiple libc.so
  [32529] stdio: fseek failure on file opened with "rm" mode after
    ungetc
  [32535] stdio: fflush failure on file opened with "rm" mode after
    ungetc
  [32541] libc: getenv cannot be overridden in static builds
  [32574] libc: pthread_attr_getstacksize/pthread_attr_getstack return
    incorrect main stack size
  [32612] dynamic-link: [aarch64 PAC] _dl_tlsdesc_dynamic can't be
    unwound through with _Unwind_Backtrace
  [32626] math: math: log10p1f is not correctly rounded
  [32627] math: math: sinhf is not correctly rounded
  [32630] math: math: tanf is not correctly rounded for all rounding
    modes
  [32653] dynamic-link: Review options for improving both security and
    backwards compatibility of glibc 2.41 dlopen / execstack handling
  [32694] math: wrong clang version 3.4 prereq checks in bits/floatn.h
    for __float128 support, should be 3.9
  [32708] libc: Inclusion of sys/mount.h triggers many gcc warnings
    using -Wshift-overflow=2 -Wsystem-headers
  [32711] math: math: remainder incorrect sign of zero result
  [32717] libc: glibc tests fail when bfd is built with --enable-error-
    execstack=yes
  [32723] math: [2.41 Regression] /usr/include/bits/floatn.h doesn't
    work with Intel SYCL compiler
  [32763] dynamic-link: Static PIE with more than one PT_LOAD segments
    at offset 0 segfault
  [32777] crypt: The performance of the rand() function degradation
  [32781] libc: Inccorect attribute access for sched_getattr
  [32782] nptl: Race conditions in pthread cancellation causing crash
  [32786] nptl: pthread_cond_* symbols should probably have had a
    version bump in 2.41
  [32795] nptl: aio_suspend_time64 confuses CLOCK_MONOTONIC and
    CLOCK_REALTIME
  [32810] dynamic-link: Immediate crash on x86-64 when running with
    GLIBC_TUNABLES=glibc.cpu.hwcaps=-XSAVEC
  [32823] libc: make[2]: *** [../Rules:248:
    /home/dave/gnu/glibc/objdir/elf/tst-origin] Error 1
  [32897] dynamic-link: pthread_getattr_np fails when executable stack
    tunable is set
  [32918] math: math: atanhf triggers UB
  [32919] math: math: coshf triggers UB
  [32920] math: math: logf triggers UB
  [32921] math: math: sinhf triggers UB
  [32922] math: math: cbrtf triggers UB
  [32923] math: math: cospif triggers UB
  [32924] math: math: erfcf triggers UB
  [32925] math: math: sinpif triggers UB
  [32932] libc: riscv: __riscv_hwprobe function attributes are incorrect
  [32947] libc: stdlib: wrong iovec array size on __libc_message_impl
  [32980] manual: getopt_long_only does not check long options first, as
    the manual claims
  [32981] ports: elf/tst-execstack-prog-static-tunable fails on
    sparc64-linux-gnu
  [32987] libc: New tst-dlopen-sgid test FAILs
  [32996] malloc: i386 TLS helper functions don't preserve XMM registers
  [33035] libc: [2.27 regression] Linux: __close_nocancel_nostatus
    clobbers errno
  [33056] string: Power 10 strcmp clobbers nonvolatile vector registers
    (CVE-2025-5702)
  [33059] string: Power 10 memchr clobbers v20
  [33060] string: Power 10 strncmp clobbers nonvolatile vector registers
    (CVE-2025-5745)
  [33088] dynamic-link: __ehdr_start may need run-time relocation
  [33089] build: [2.42 Regression] GCC 14.2.1 failed to build glibc
  [33134] libc: mcount_internal shouldn't use vector/r16-r31 registers
    nor call memcpy/memset
  [33139] stdio: %n after static dlopen is unreliable if file
    descriptors are exhausted
  [33165] build: [2.42 Regression] FAIL: elf/check-localplt
  [33173] math: Wrong IFUNC selector is used for modf/modff
  [33185] regex: Double-free after memory allocation failure in regcomp
    bracket expression parsing (CVE-2025-8058)
  [33224] dynamic-link: _dl_debug_state hook no longer works (since
    8329939a37f483a16013dd8af8303cbcb86d92cb)

Version 2.41

Major new features:

* Support for testing a glibc build with a set of C and C++ compilers
  different from the C and C++ compilers used to build glibc has been
  added:
  $ ../configure TEST_CC="gcc-6.4.1" TEST_CXX="g++-6.4.1"

  This includes support for testing the glibc build with Clang, e.g.,
  $ ../configure TEST_CC="clang" TEST_CXX="clang++"

  Some run-time failures with Clang are expected.

* The glibc test suite has been extended again significantly, with now
  6232 separate tests compared to 5408 in glibc-2.40.

* In /etc/resolv.conf and the RES_OPTIONS environment variable, option
  flags can now be prefixed with “-” to clear previously set flags.
  For example, if /etc/resolv.conf contains “options no-aaaa”, a
  process running with the RES_OPTIONS=-no-aaaa environment variable
  performs AAAA DNS queries when the glibc DNS stub resolver is used.

* The DNS stub resolver now supports the strict-error option.  If
  activated, getaddrinfo for the AF_UNSPEC address family (with dual
  A/AAAA DNS lookups) attemps to obtain an A/AAAA response pair from
  another DNS server if one of the responses indicates failure.  Without
  the strict-error option, getaddrinfo returns the A record data it has
  obtained even if the AAAA query failed.  The new strict error mode is
  incompatible with some DNS environments which do not follow the RFCs,
  which is why this mode is not enabled by default.  A future version
  of the library may turn it on by default, however.

* On Linux, the sched_setattr and sched_getattr functions have been
  added, for supporting parameterized scheduling policies such as
  SCHED_DEADLINE.

* The iconv program now supports converting files in place.  The program
  automatically uses a temporary file if required.

* Character encoding, character type info, and transliteration tables
  have been updated to Unicode 16.0.0.

* The following ISO C23 function families (introduced in TS
  18661-4:2015) are now supported in <math.h>.  Each family includes
  functions for float, double, long double, _FloatN and _FloatNx, and a
  type-generic macro in <tgmath.h>.

  - Trigonometric functions: acospi, asinpi, atan2pi, atanpi, cospi,
    sinpi, tanpi.

* The GNU C Library now supports a feature test macro _ISOC2Y_SOURCE to
  enable features from the draft ISO C2Y standard.  Only some features
  from this draft standard are supported by the GNU C Library, and as
  the draft is under active development, the set of features enabled by
  this macro is liable to change.  Features from C2Y are also enabled
  by _GNU_SOURCE, or by compiling with "gcc -std=gnu2y".

* Optimized and correctly rounded exp10m1f, exp2m1f, expm1f, log10f,
  log2p1f, log1pf, log10p1f, cbrtf, erff, erfcf, lgammaf, tgammaf,
  tanf, acosf, acoshf, asinf, asinhf, atanf, atan2f, atanhf, coshf,
  sinhf, and tanhf functions have been added from the CORE-MATH
  project <https://core-math.gitlabpages.inria.fr/>.

* A benchtest framework is now in place to track the performance of many
  (mostly numerical) functions.

* A new tunable, glibc.rtld.execstack, can be used to control whether an
  executable stack is allowed from the main program, either implicitly
  due to a mising GNU_STACK ELF header or explicit explicitly because
  of the executable bit in GNU_STACK.  The default is to allow
  executable stacks.

* Support for the extensible rseq ABI introduced in the Linux kernel
  version 6.3 has been added.  The size and alignment of the rseq area
  is now determined by auxiliary vector entries when provided by the
  running kernel.  This results in __rseq_size now exposing features
  past the original ABI which currently include 'node_id' and 'mm_cid'
  and will also allow exposing new features as they get added to future
  Linux kernels.

* The GNU C Library now supports the Guarded Control Stack extension
  that allows to use shadow stacks on AArch64 systems that support this
  extension.  Building the library with standard branch protection
  enabled while using a toolchain that supports GCS (binutils 2.44 and
  GCC 15 or later) will enable GCS support in glibc.  There is no
  special configuration flag.  GCS-enabled glibc is compatible with all
  existing executables and shared libraries and will run with and
  without GCS support in the system.  GCS is opt-in and can be
  controlled at runtime via the glibc.cpu.aarch64_gcs tunable. By
  default GCS is disabled.  Linux kernel supports this since 6.13.

* Significant effort has been put into improving the code generation
  and speed of mathematical functions in the vector mathematics library
  on AArch64, with regard to the Scalable Vector Extension (SVE) and
  Advanced SIMD (Neon) intrinsics.

* Support for memory protection keys on AArch64 systems with enabled
  Stage 1 permission overlays feature as introduced in Armv8.9 / 9.4
  has been added.

* On PowerPC64, support for the return-oriented programming protection
  instructions added in ISA 3.1 (Power10) has been added, as well as
  function optimizations for Power10.

* A new architecture type has been introduced internally to better
  support Hygon x86-64 processors.

Deprecated and removed features, and other changes affecting
compatibility:

* abort is now async-signal-safe and its implementation makes longjmp
  from the SIGABRT handler always abort if set up with setjmp.  Use
  sigsetjmp to keep the old behavior, where the handler does not stop
  the process execution.

* dlopen and dlmopen no longer make the stack executable if a shared
  library requires it, either implicitly because of a missing GNU_STACK
  ELF header (and default ABI permission having the executable bit set)
  or explicitly because of the executable bit in GNU_STACK, and the
  stack is not already executable.  Instead, loading such objects will
  fail.

* The nios2*-*-linux-gnu configurations are no longer supported.

* The big-endian ARC port (arceb-linux-gnu) has been removed.

Changes to build and runtime requirements:

* On recent Linux kernels with vDSO getrandom support, getrandom does
  not act as a "shall occur" cancellation point, in which case it might
  not issue a syscall or trigger a deferred cancellation event.

* Testing the GNU C Library requires GNU awk to be compiled with support
  for high precision arithmetic via the MPFR library.

Security related changes:

The following CVEs were fixed in this release, details of which can be
found in the advisories directory of the release tarball:

  GLIBC-SA-2025-0001:
    assert: Buffer overflow when printing assertion failure message
    (CVE-2025-0395)

The following bugs were resolved with this release:

  [6050] locale: iconv(1) buffers all of stdin in memory
  [10460] locale: iconv does not support in-place conversion
  [12683] nptl: Race conditions in pthread cancellation
  [14147] nptl: Async cancellation left active after longjmp out of
    signal handler
  [14799] network: RES_OPTIONS cannot disable options enabled in
    /etc/resolv.conf
  [17703] locale: iconv(1) EFAULTs reading the second non-mmapable input
  [20632] stdio: Buffer overflow in wchar IO (_IO_wfile_overflow)
  [23675] stdio: freopen() with "ccs=<charset>" leaves the stream
    unoriented
  [25847] nptl: pthread_cond_signal failed to wake up pthread_cond_wait
    due to a bug in undoing stealing
  [26275] libc: abort(3) is not signal-safe
  [27543] ports: Inconsistent behavior when handling FPSCR on SH
  [27821] stdio: double call to ungetc causes uninitialized memory
    reading. (also: ungetc causes memory leak)
  [29437] libc: arc4random is too slow
  [30009] build: unterminated options list in benchtest
  [30081] network: libresolv: timeout when running in single-request
    mode
  [30220] math: String to double returns incorrectly rounded value for
    hexadecimal subnormal
  [30584] libc: initstate and initstate_r crash when the state argument
    is unaligned
  [30647] stdio: scanf functions wrong on nan()
  [31394] libc: clone on sparc might fail with -EFAULT for no valid
    reason
  [31717] dynamic-link: TLS for library gets reallocated when loaded in
    two contexts.
  [31799] dynamic-link: -static-pie -Wl,-Ttext-segment=0x50000 doesn't
    work
  [31859] locale: Transliteration rules with two input characters like
    "ḌḌ" "DDH" do not work.
  [31890] network: DNS stub resolver ignores header-only error responses
  [31928] build: glibc doesn't compile if the compiler already define
    _FORTIFY_SOURCE
  [31968] libc: mremap implementation in C does not handle arguments
    correctly
  [31985] dynamic-link: la_objopen not called when ld.so is imported
    into a private namespace. However, la_objclose is called with an
    unknown cookie.
  [31997] libc: exit is not thread-safe, even when all atexit handlers
    are thread-safe
  [32026] libc: strerror, strsignal TLS not handled correctly for
    secondary namespaces (dlmopen, LD_AUDIT)
  [32033] locale: iconv (the program) does not truncate output file if
    input is empty
  [32040] nptl: CPU affinity test skeleton for sched_setaffinity and
    pthread_setaffinity_np can fail to report failure.
  [32042] build: Compilation issue for tst-resolv-short-response.c with
    older GCC
  [32045] math: nan() / strtod() incorrectly set errno for overflowing
    nan payload
  [32046] locale: iconv -c fails to report input encoding errors if
    output buffer is full
  [32047] libc: Tunables may incorrectly set Prefer_PMINUB_for_stringop
  [32050] locale: iconv - - < /dev/null fails with Bad file descriptor
  [32052] libc: stdlib.h's use of 'sz' identifier causes libstdc++ test
    failure
  [32065] dynamic-link: _dl_fini does not call la_objclose for proxy
    link maps
  [32066] dynamic-link: dlclose signals la_activity (LA_ACT_DELETE)
    after la_objclose calls
  [32078] string: Random __strchrnul_evex512 failures
  [32124] libc: readdir_r does not relay errors reported by the kernel
  [32125] libc: powerpc: Missing TOC stub in __syscall_cancel_arch for
    powerpc64le-linux-gnu
  [32126] libc: readdir64_r: Do not skip entries with zero d_ino values
  [32128] libc: Compat readdir64_r (__old_readdir64_r) does not enforce
    NAME_MAX limit
  [32134] stdio: freopen does not clear flags2 (FD_CLOEXEC etc)
  [32137] libc: libio/tst-stderr-compat, libio/tst-bz24228, math/test-
    matherr-2, nptl/tst-pthread_kill-exited fails on powerpc-unknown-
    linux-gnu
  [32140] stdio: freopen leaks memory on failure
  [32145] libc: New stdlib/tst-strtod1i, stdlib/tst-strtod3, stdlib/tst-
    strtod4, stdlib/tst-strtod5i failures on powerpc64le-linux-gnu
  [32148] stdio: Memory corruption with ancient i386 binaries using
    stdio
  [32168] localedata: Update locale data to Unicode 16.0.0
  [32173] libc: sparc: restartable syscalls are broken
  [32192] build: s390: utf16-utf32-z9.c fails to build w/ -fomit-frame-
    pointer
  [32197] locale: FAIL: iconv/tst-iconv_prog-buffer failures
  [32212] string: x86_64/strcmp caused 25% performance drop by commit
    84e7c46df
  [32214] libc: random_bits always returns the same value if getrandom
    fails
  [32215] libc: Signal handlers after fork may encounter missing robust
    mutex list
  [32228] libc: .preinit_array in /lib/riscv64-linux-gnu/Scrt1.o is not
    properly aligned
  [32231] dynamic-link: ldconfig auxcache format change in 2.36
  [32233] libc: error calls va_end twice.
  [32234] hurd: missing va_end call in fcntl.c
  [32245] build: glibc -Wstringop-overflow= build failure on hppa
  [32280] localedata: Enable transliteration rules with two input
    characters in scn_IT
  [32283] libc: Compilation issue for tst-syscall-restart.c with GCC
    10.2.1
  [32323] localedata: eo: Incorrect first day of week and first week of
    year
  [32344] string: Assembler warnings when building strcpy-evex.S and
    strncpy-evex.S
  [32350] hurd: function __xpg_strerror_r crashes for specific arguments
  [32360] stdio: Compilation issue for tst-printf-format-skeleton.c with
    GCC 10.2.1
  [32366] malloc: malloc test failures with GCC 15
  [32380] locale: dcigettext can cause SIGSEGV when domain name is too
    long
  [32414] libc: [x86_64 regression] tst-strtod5i.c:124:(.text+0x47c):
    undefined reference to `__copysignf128'
  [32418] math: __XXX math functions are declared, but not provided
  [32420] build: GCC 6 can't build glibc 2.41
  [32440] libc: getrandom() in glibc 2.41 (development) returns EINVAL
    as retcode instead of errno on powerpc64le
  [32448] libc: iconv reports failure with successful transliteration
  [32450] libc: system() does not return -1 if a child process can't be
    created
  [32465] nss: ./getaddrinfo.c:1884:11: error: variable 'endp' is used
    uninitialized whenever '||' condition is true [-Werror,-Wsometimes-
    uninitialized]
  [32470] dynamic-link: Integer truncation during x86-64 cache size
    computation
  [32488] libc: Glibc failed to build with CET enabled
  [32492] libc: New test failures
  [32494] build: Compilation issue with GCC 14.2.1
  [32508] dynamic-link: ldd: /lib/ld-linux.so.2: cannot execute binary
    file: Exec format error
  [32512] dynamic-link: failure to build on loong, undefined reference
    to `stpcpy'
  [32543] build: x32 glibc is miscompiled
  [32588] libc: [2.41 regression] bash crashes with 'realloc(): invalid
    pointer' with `env -i PATH=`

Version 2.40

Major new features:

* The <stdbit.h> header type-generic macros have been changed when using
  GCC 14.1 or later to use __builtin_stdc_bit_ceil etc. built-in functions
  in order to support unsigned __int128 and/or unsigned _BitInt(N) operands
  with arbitrary precisions when supported by the target.

* The GNU C Library now supports a feature test macro _ISOC23_SOURCE to
  enable features from the ISO C23 standard.  Only some features from
  this standard are supported by the GNU C Library.  The older name
  _ISOC2X_SOURCE is still supported.  Features from C23 are also enabled
  by _GNU_SOURCE, or by compiling with the GCC options -std=c23,
  -std=gnu23, -std=c2x or -std=gnu2x.

* The following ISO C23 function families (introduced in TS
  18661-4:2015) are now supported in <math.h>.  Each family includes
  functions for float, double, long double, _FloatN and _FloatNx, and a
  type-generic macro in <tgmath.h>.

  - Exponential functions: exp2m1, exp10m1.

  - Logarithmic functions: log2p1, log10p1, logp1.

* A new tunable, glibc.rtld.enable_secure, can be used to run a program
  as if it were a setuid process. This is currently a testing tool to allow
  more extensive verification tests for AT_SECURE programs and not meant to
  be a security feature.

* On Linux, the epoll header was updated to include epoll ioctl definitions
  and the related structure added in Linux kernel 6.9.

* The fortify functionality has been significantly enhanced for building
  programs with clang against the GNU C Library.

* Many functions have been added to the vector library for aarch64:
    acosh, asinh, atanh, cbrt, cosh, erf, erfc, hypot, pow, sinh, tanh

* On x86, memset can now use non-temporal stores to improve the performance
  of large writes. This behaviour is controlled by a new tunable
  x86_memset_non_temporal_threshold.

Deprecated and removed features, and other changes affecting compatibility:

* Architectures which use a 32-bit seconds-since-epoch field in struct
  lastlog, struct utmp, struct utmpx (such as i386, powerpc64le, rv32,
  rv64, x86-64) switched from a signed to an unsigned type for that
  field.  This allows these fields to store timestamps beyond the year
  2038, until the year 2106.  Please note that applications are still
  expected to migrate off the interfaces declared in <utmp.h> and
  <utmpx.h> (except for login_tty) due to locking and session management
  problems.

* __rseq_size now denotes the size of the active rseq area (20 bytes
  initially), not the size of struct rseq (32 bytes initially).

Security related changes:

The following CVEs were fixed in this release, details of which can be
found in the advisories directory of the release tarball:

  GLIBC-SA-2024-0004:
    ISO-2022-CN-EXT: fix out-of-bound writes when writing escape
    sequence (CVE-2024-2961)

  GLIBC-SA-2024-0005:
    nscd: Stack-based buffer overflow in netgroup cache (CVE-2024-33599)

  GLIBC-SA-2024-0006:
    nscd: Null pointer crash after notfound response (CVE-2024-33600)

  GLIBC-SA-2024-0007:
    nscd: netgroup cache may terminate daemon on memory allocation
    failure (CVE-2024-33601)

  GLIBC-SA-2024-0008:
    nscd: netgroup cache assumes NSS callback uses in-buffer strings
    (CVE-2024-33602)

The following bugs are resolved with this release:

  [19622] network: Support aliasing with struct sockaddr
  [21271] localedata: cv_RU: update translations
  [23774] localedata: lv_LV collates Y/y incorrectly
  [23865] string: wcsstr is quadratic-time
  [25119] localedata: Change Czech weekday names to lowercase
  [27777] stdio: fclose does a linear search, takes ages when many FILE*
    are opened
